#ifndef __ANALYZE__HPP
#define __ANALYZE__HPP

#include "../initialization.hpp"
#include "trajectory.hpp"
#include "dropsize.hpp"
#include "dropvelocity.hpp"
#include "dropsphericalstress.hpp"
#include "radialdensity.hpp"


namespace dpd{

class Analyze{
private:

    Initialization* init;
    Command *command;
    Configuration *config;
    Control *control;
    Topology *topol;
    SetMPI* mpi;
    ParticleList particles;
    Timer* timer;
    Trajectory* traj;
    int program;
    Property* prop;
    int nsteps;
    int begstep;
    int endstep;
    int skipstep;
    int nsteps_proc;
    int ncalcproc;
    bool multicore;
    
//    Communication* commun;

public:
    Analyze(){}
    Analyze(Initialization *init);
    ~Analyze(){}

    void loadProperty();
    void analyzeProperty();

};
};

#endif
