#ifndef __DROPGYRATION__HPP
#define __DROPGYRATION__HPP

#include "property.hpp"
#include "particlegroup.hpp"
namespace dpd{

class DropGyration:public Property{
private:
    real dz;
    real dcrit;
    std::vector<ParticleGroup*> particles_atz;
    int numz;
    real surfacet, surfaceb;
    R3vec com;
    real dr;
    int numr;
    Ivec liquididx;
    Svec liquidgrps;
    int nliqptcls;
    Rvec rdensity;
    R3vec ref0, ref1;
    Rvec radius;
    Rvec maxd_vsh;


    


public:
    DropGyration(){}
    DropGyration(InitialSet initset);
    ~DropGyration();

    virtual void getSpecificParameters();
    virtual void initializeVariables();
    virtual void calculateStep(int step);
};
};



#endif
