#ifndef __DROPSURFTENSION__HPP
#define __DROPSURFTENSION__HPP

#include "property.hpp"
#include "particlegroup.hpp"
#include "../force.hpp"
#include "../localdensity.hpp"
namespace dpd{
class DropSurfTension:public Property{
private:
    Real3D com;
    Real3D ref0;
    Real3D ref1;
    ParticleGroup ptcls;
    Decomposition *decomp;
    Configuration *config;
    Force* force;
    LocalDensity *localdensity;
    real** press;

    

public:
    DropSurfTension(){}
    DropSurfTension(Initialization* init);
    ~DropSurfTension(){}

    virtual void initialize();
    virtual void getParameters();
    virtual void setDefault();
    virtual void bcastParameters();
    virtual void calculateStep(int step);

    virtual void normalizeDistribution();

};
};

#endif
                        
