#ifndef __OUTWRITE__HPP
#define __OUTWRITE__HPP
#include "property.hpp"
#include <iostream>
#include <fstream>

namespace dpd{

class OutWrite{
private:
    Property* prop;
    SetMPI* mpi;
    std::string outname;
    std::string outtimename;
    std::string outdistname;
    std::string outdynmname;
    std::string outtimetitle;
    std::string outdisttitle;
    std::string outdynmtitle;
    std::string outtimeheader;
    std::string outdistheader;
    std::string outdynmheader;
    Rvec2D results;

    int begstep;
    int endstep;
    int nsteps;
    int skipstep;
    real dt;
    Ivec dsteps;

    real distbegin;
    real distbin;


public:
    OutWrite(){}
    OutWrite(Property* prop);
    ~OutWrite(){}
   
    void generateOutFileName();
    std::string generateOutputHeader(Svec hd);
    void writeTimeEvolution();
    void writeDistribution();
    void writeDistribution(Rvec xaxis);
    void writeDynamics();
};
};

#endif
