#ifndef __INITANALYSIS__HPP
#define __INITANALYSIS__HPP
#include "../initialization.hpp"
#include "../command.hpp"
#include "trajectory.hpp"
#include "dropsize.hpp"
#include "dropvelocity.hpp"
#include "dropsphericalstress.hpp"
#include "radialdensity.hpp"
#include "averagestress.hpp"
#include "polymeradsorption.hpp"
#include "polymersize.hpp"
#include "polymereevecrelax.hpp"
#include "polymerorientation.hpp"
#include "polymerbondlength.hpp"
#include "polymerstretch.hpp"
#include "polymerlocalconc.hpp"
#include "trjtogro.hpp"
#include "polymersmsf.hpp"
#include "polymerinternalsize.hpp"
#include "msd.hpp"
#include "velacf.hpp"
#include "surfacecoverage.hpp"
#include "rdf.hpp"
#include "polymerdepositorient.hpp"
#include "bridgesize.hpp"
#include "bridgevelocity.hpp"


namespace dpd{

class InitAnalysis:public Initialization{
private:
    int program;
    Property* prop;
    InitialSet initset;
    Trajectory* traj;


    bool multicore;
    
    int nbeads;
    int nsteps;
    int begstep;
    int endstep;
    int skipstep;


    void loadProperty();
    void checkNumberOfCoresForProgram();

public:
    InitAnalysis(){}
    InitAnalysis(Command* command);
    ~InitAnalysis();

    int getNbeads(){ return nbeads; }
    int getNsteps(){ return nsteps; }
    int getBeginStep(){ return begstep; }
    int getEndStep(){ return endstep; }
    int getSkipStep(){ return skipstep; }
    bool needMultiCore(){ return multicore; }

    Property* getProperty(){ return prop; }
    Trajectory* getTrajectory(){ return traj; }




};
};


#endif
